#!/usr/bin/python
# -*- coding: utf-8 -*-

# question

from random import choice
class Question(object):
    text = ""
    correctAnswer = ""
    package = None
    type = ""
    points = 1
    
    def __init__(self,package=None):
        
        self.package = package
        self.generate()
    
    def generate(self):
        "Will need to be overwritten"
        self.text = ""
        self.correctAnswer = ""
        
    def getCorrectAnswer(self):
        return self.correctAnswer
    
    def getText(self):
        return self.text
    
    def setPackage(self,package):
        self.package = package
        
class definition(Question):
    
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.type = "definition"    
    def generate(self):
        self.text = "What is " + str(self.package.name)
        self.correctAnswer = str(self.package.desc)
        
class depends(Question):
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.type = "depends"
        self.points = 2
    
    def generate(self):
        self.text = "Which one of the following does " + self.package.name + " depend on?"
        self.correctAnswer = self.package.depends
            
class requiredBy(Question):
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.type = "requiredBy"
        self.points = 3
    
    def generate(self):
        
        self.text = str(self.package.name) + " is required by which one of the following packages?"
        self.correctAnswer = self.package.compute_requiredby()
        
class installedSize(Question):
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.points = 6
        self.type = "installedSize"
        
    def generate(self):
        
        self.text = "How much is the installed size of " + self.package.name + " (in kilobytes)"
        self.correctAnswer = self.package.isize

class packager(Question):
    
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.type = "maintainer"
        self.points = 6
        
    def generate(self):
        
        self.text = "Who is the packager of " + self.package.name
        self.correctAnswer = self.package.packager
        
class fileOwner(Question):
    
    def __init__(self,package = None):
        Question.__init__(self,package)
        self.type = "fileOwner"
        self.points = 3
    
    def generate(self):
        
        file = choice(self.package.files)
        while file.endswith("/"):
            file = choice(self.package.files)
        self.text = "Which package installed this file: " + file
        self.correctAnswer = self.package.name
    
    
    